add rescue, fix default pxe, ubuntu locale
[automated-distro-installer] / fai-revm
index 6271a36bfa4980f3be53fa0ca4dd1efe977d4141..68840bd9d962c1c3cac9570464796f8a4f64dc3a 100755 (executable)
--- a/fai-revm
+++ b/fai-revm
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-set -x
 
-# Note, sometimes shutting down the existing demohost vm
-# fails. Just run again if that happens.
 
-# Deploy fai configuration to faiserver,
-# then start a virtual machine to test the config.
 
 cleanup() { :; }
 set -eE -o pipefail
@@ -29,13 +24,43 @@ script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
 
 e() { echo "$*"; "$@"; }
 
-# I had this set false as default before, can't remember why. oh well.
-redeploy=true
-if [[ $1 == -r ]]; then
-    redeploy=false
-fi
 
-disk_count=2
+usage() {
+    cat <<EOF
+# Usage: ${0##*/} [OPTIONS]
+Setup fai or arch pxe (depending on $0 name)
+then start a virtual machine to test the config
+
+Note, sometimes shutting down the existing demohost vm
+fails. Just run again if that happens.
+
+-r         Do not boot after install is complete
+-n         Create new qcow2(s) for vm. Good for testing partitioning
+           script, to ensure a blank disk.
+-h|--help  Print help and exit.
+
+Note: Uses GNU getopt options parsing style
+EOF
+    exit $1
+}
+
+new_disk=false
+temp=$(getopt -l help hnr "$@") || usage 1
+eval set -- "$temp"
+while true; do
+    case $1 in
+        -n) new_disk=true; shift ;;
+        -r) reboot_arg=--noreboot; shift ;;
+        -h|--help) usage ;;
+        --) shift; break ;;
+        *) echo "$0: Internal error!" ; exit 1 ;;
+    esac
+done
+
+
+# change this to test different disk counts. 1 and > 1 should be the only
+# important things to test.
+disk_count=1
 
 
 if [[ $script_dir == /a/bin/* ]]; then
@@ -53,22 +78,23 @@ is_arch_revm() {
     [[ ${0##*/} == arch-revm ]]
 }
 
-new_disk=false
-[[ ! $1 ]] || new_disk=true
-
-cleanup() { ./pxe-server :; }
+cleanup() {
+    ./pxe-server
+    ./faiserver-disable
+}
 if is_arch_revm; then
-    ./pxe-server arch
+    ./pxe-server demohost arch
     sleep 2
     # via osinfo-query os. guessing arch is closest to latest fedora.
     variant=fedora22
 else
-    ./pxe-server fai
+    ./pxe-server demohost fai
     sleep 2
-    if $redeploy; then
-        ./fai-redep
-    fi
-    variant=debian8
+    # I don't think these variants actually make a diff for us, but I
+    # use the appropriate one when trying a new distro just in case.
+    variant=ubuntu14.04
+    #variant=ubuntu16.04
+    #variant=debian8
 fi
 
 name=demohost
@@ -96,7 +122,7 @@ fi
 #
 # uniq is to stop gtk-warning spam
 e s virt-install --os-variant $variant  -n $name --pxe -r 2048 --vcpus 1 \
-  ${disk_arg[*]} -w bridge=br0,mac=52:54:00:9c:ef:ad \
+  ${disk_arg[*]} -w bridge=br0,mac=52:54:00:9c:ef:ad $reboot_arg \
   --graphics spice,listen=0.0.0.0 $console_arg |& grep -v '^ *$' | uniq &
 
 if [[ $SSH_CLIENT ]]; then
@@ -104,9 +130,11 @@ if [[ $SSH_CLIENT ]]; then
 fi
 
 sleep 30
-while ! timeout -s 9 10 ssh root@$name /bin/true; do sleep 5; done
+while ! timeout -s 9 10 ssh -oBatchMode=yes root@$name /bin/true; do
+    e sleep 5
+done
 cleanup() { :; }
-pxe-server :
+e pxe-server
 if is_arch_revm; then
     ./arch-init-remote $name
 fi